%function: load pocket from txt file
function P=load_pocket(fname,fnumlabs,tweights,maxradius,bligand)
if nargin<5
    bligand=0;
end
    
f1=fopen(fname,'r');
txt=fgetl(f1);P.labels=[];P.coords=[];P.lcoords=[];lig=[];P.labels_num=[];P.weights=[];P.pdb=[];P.lpdb=[];P.llabels=[];
while(txt~=-1)
    if strcmp(txt(1:3),'END') txt=fgetl(f1);continue;end;
    if ~((strcmp(txt(1:4),'ATOM')) || (strcmp(txt(1:4),'HETA'))) txt=fgetl(f1);continue;end;
 %   if strcmp(txt(1:4),'HETA') txt=[txt '*'];end;
    if (txt(1)~='*') && (txt(end)~='*')
        txt(17)=' ';
        tcoords=txt(31:54);%txt(end-51:end-26);
        pdb1=txt(1:30);
        pdb2=txt(55:end);
        while ~isempty(strfind(txt,'  ')) txt=strrep(txt,'  ',' ');end;
        p=strfind(txt,' ');
        P.labels(end+1).name=[txt(p(4)-3:p(4)-1) '_' txt(p(2)+1:p(3)-1)];
        P.coords(end+1,:)=[str2num(tcoords(1:8)) str2num(tcoords(9:16)) str2num(tcoords(17:24))];%txt(p(end-6)+1:p(end-3)));
        P.pdb(end+1).pdb1=pdb1;P.pdb(end).pdb2=pdb2;
        if strcmp(fnumlabs,'ChPart')
            p=strfind(txt,'>');
            p1=strfind(txt(p+2:end),' ');
	    %disp(txt(p+p1(2)+1:p+p1(3)))
            if length(p1)<3
                dbg=1;
            end
            if isempty(str2num(txt(p+p1(2)+1:p+p1(3))))
    	      P.labels_num(end+1)=-0.548;
         %     disp(txt)
            else
    	      P.labels_num(end+1)=str2num(txt(p+p1(2)+1:p+p1(3)));
            end;
        end
	if (tweights>0) %extract weights depending on distance 
        p=strfind(txt,' ');
	    P.weights(end+1)=exp(-tweights*str2num(txt(p(end):end)));
	else
	    P.weights(end+1)=1;	
	end
	if (maxradius>0) %filtr out some points, hard threeshold				
        p=strfind(txt,' ');
	    rcur=str2num(txt(p(end):end));
	    if (rcur>maxradius)
            P.weights(end)=[];
	        P.labels(end)=[];
            if length(P.labels_num)>0
                P.labels_num(end)=[];
            end
            P.coords(end,:)=[];
            P.pdb(end)=[];
	    end
	end
    else
        %extract ligand type
        lig=txt(18:20);
        tcoords=txt(31:54);
        P.lcoords(end+1,:)=[str2num(tcoords(1:8)) str2num(tcoords(9:16)) str2num(tcoords(17:24))];
        P.lpdb(end+1).pdb1=txt(1:30);
        P.lpdb(end).pdb2=txt(55:end);
        P.llabels(end+1)=txt(end-3:end-3);
        %extract ligand coordiantes
    end
    txt=fgetl(f1);
end
fclose(f1);
P.center_coord=mean(P.coords);
if (size(P.lcoords,1)>0)
    P.lcoords=P.lcoords-repmat(mean(P.coords),size(P.lcoords,1),1);
else
    P.lcoords=zeros(1,3);
end
P.coords=P.coords-repmat(mean(P.coords),size(P.coords,1),1);
P.lig=lig;
if ~strcmp(fnumlabs,'ChPart')
    P=get_numlabels(P,fnumlabs,0);
end
if strcmp(fnumlabs,'ChComp')
    for i=1:length(P.pdb)
        p=strfind(P.pdb(i).pdb2,'>');
        P.labels(i).name=P.pdb(i).pdb2(p+2:p+4);
    end
end
if strcmp(fnumlabs,'SimA')
    for i=1:length(P.pdb)
              p=strfind(P.pdb(i).pdb2,'>');
              P.labels_num(i)=P.pdb(i).pdb2(p-4:p-4);
    end
end
if bligand
    P.coords=P.lcoords;
    P.coords=P.coords-repmat(mean(P.coords),size(P.coords,1),1);
    P.labels_num=ones(size(P.coords,1),1);
    P.weights=ones(1,size(P.coords,1));
end
end

%%%%%%%%%%%%%%%%%%%KERNEL FOR AMINO ACIDS%%%%%%%%%%%%%%%%%%%%
function P=get_numlabels(P,fname,defval)
AA={'Ala' 'Arg' 'Asn' 'Asp' 'Cys' 'Glu' 'Gln' 'Gly' 'His' 'Ile' 'Leu' 'Lys' 'Met' 'Phe' 'Pro' 'Ser' 'Thr' 'Trp' 'Tyr' 'Val'};
for i=1:length(AA) AA{i}=upper(AA{i});end;

for i=1:length(P.labels)
    if strcmp(P.labels(i).name(end-1:end),'_O')
       P.labels_num(i,1)=length(AA)+1;
       continue;
    end
    if strcmp(P.labels(i).name(end-1:end),'_N')
       P.labels_num(i,1)=length(AA)+2;
       continue;
    end
    for j=1:length(AA)
        if strcmp(AA{j},P.labels(i).name(1:3))
            P.labels_num(i,1)=j;
        end
    end
end

end%function
%%%%%%%%%%%%%%%%%%%ATOM PARTICULAR CHARGES%%%%%%%%%%%%%%%%%%%%
function P=get_numlabels_pch(P,fname,defval)
%num labels loading
f1=fopen(fname,'r');
txt=fgetl(f1);numlabs=[];
while(txt~=-1)
    p=strfind(txt,' ');
    label1=txt(1:p(1)-1);
    i=2;
    while i<length(p)
	    label2=txt(p(i-1)+1:p(i)-1);
	    i=i+1;
	    num=str2num(txt(p(i-1)+1:p(i)-1));
            numlabs(end+1).name=[label1 '_' label2];
            numlabs(end).num=num;
	   i=i+1;
    end
    txt=fgetl(f1);
end
fclose(f1);
%num labels association
for i=1:length(P.labels)
 	P.labels_num(i,1)=defval;
	bfind=false;
	for j=1:length(numlabs)
		if strcmp(numlabs(j).name,P.labels(i).name)
			P.labels_num(i,1)=numlabs(j).num;
			bfind=true;
		end
	end
	if ~bfind
		subslabel=P.labels(i).name;
		p=strfind(subslabel,'_');	
		subslabel(1:p(1)-1)='ALL';	
		for j=1:length(numlabs)
		if strcmp(numlabs(j).name,subslabel)
			P.labels_num(i,1)=numlabs(j).num;
		end
		end
	end
end
end %function
