function [x,exit_parameters]=minimize_limited_quasi_newton(x,fun,optparam,varargin);
%modified version with other routine

tol = optparam.tol;
kmax = optparam.kmax;
display = optparam.display;
n = size(x,1);
dx=2*tol;
k=1;
go_on = 1;
if isfield(optparam,'kmax_ls'), kmax_ls = optparam.kmax_ls;
else, kmax_ls = 40 ; end
if isfield(optparam,'lmax'), lmax = optparam.lmax;
else, lmax = 5; end
if isfield(optparam,'m1_WOLFE'), m1_WOLFE = optparam.m1_WOLFE;
else, m1_WOLFE = .001 ; end
if isfield(optparam,'m1_WOLFE'), m2_WOLFE = optparam.m2_WOLFE;
else, m2_WOLFE = .9 ; end
if isfield(optparam,'tol_df'), tol_df = optparam.tol_df;
else, tol_df = sqrt(tol)/100; end
df = 2*tol_df;
if isfield(optparam,'rho_GOLDSTEIN'), rho_GOLDSTEIN = optparam.rho_GOLDSTEIN;
else, rho_GOLDSTEIN = .25 ; end
if isfield(optparam,'t_GOLDSTEIN'), kmax_ls = optparam.t_GOLDSTEIN;
else, t_GOLDSTEIN = 2 ; end
disp([display tol tol_df kmax]);
fxold = Inf;fx=0;
xold = x;
nevals = 0;
lambda2old = 0;
alpha0 = 1;
nevals = 0;
kls = 0;gradient=1;exit_parameters.fx=[];
while go_on & k<kmax & (df > tol_df)& (norm(gradient)>0.01);
    % compute gradient
   
    [fx,gradient] = feval(fun,varargin{:},x);exit_parameters.fx(end+1)=fx;
    
    nevals = nevals + 1;
    if 0
        % check gradients
        ddx = randn(size(x));
        dr =1e-8;
        [dfx,dgradient] = feval(fun,varargin{:},x+dr*ddx);
        abs((dfx-fx)-dr * gradient'*ddx)/abs(dfx-fx)

        %          ddx = randn(size(x));
        dr =1e-6;
        [dfx,dgradient] = feval(fun,varargin{:},x+dr*ddx);
        abs((dfx-fx)-dr * gradient'*ddx)/abs(dfx-fx)

        pause
    end


    df = fxold-fx;

    if k==1
        ln=1;
        l=0;
        S=zeros(size(x,1),lmax);
        Y=zeros(size(x,1),lmax);
        W0 = 1;
        beta = 0;
        descent = - gradient;
        lambda2= - descent'*gradient;
%         H = eye(n);
    else

        % update BFGS-matrix
        s=x-xold;
        y=gradient-gradold;
        sty=s'*y;
        if sty>=1e-8*norm(s)*norm(y)
            S(:,ln)=s;
            Y(:,ln)=y;
            l=min(l+1,lmax);
            ln=mod(ln,lmax)+1;
            if l==lmax
                W0 = 1; %s'*y / (y'*y);
            end
        end


        % compute BFGS-step descent=-B*g;
        q=gradient;
        for j=1:l
            i=mod(ln-j-1,lmax)+1;
            ga(i)=(S(:,i)'*q)/(Y(:,i)'*S(:,i) );
            q=q-ga(i)*Y(:,i);
        end
        r=W0*q;
        for j=l:-1:1
            i=mod(ln-j-1,lmax)+1;
            be=(Y(:,i)'*r)/(Y(:,i)'*S(:,i) );
            r=r+(ga(i)-be)*S(:,i);
        end
        descent=-r;



%         % bfgs update
%         Dx = x - xold;
%         Dg = gradient - gradold;
%         HDg = H * Dg;
%         if 0%( ( Dx' * Dg ) < 1e-15 || ( HDg' * Dg ) < 1e-15 || ( HDg' * HDg ) < 1e-15 )
%             H = eye(n);
%             beta = 0;
%         else
%         %                 u = Dx / ( Dx' * Dg ) - HDg / ( HDg' * Dg );
% %                 H = H ...
% %                     + ( Dx * Dx' ) / ( Dx' * Dg ) ...
% %                     - ( HDg * HDg' ) / ( Dg' * HDg) ...
% %                     + ( HDg' * Dg ) * u * u';
%                 H = H - ( Dx * HDg' + HDg * Dx' ) / ( Dg' * Dx ) + ( 1 + ( Dg' * HDg) / (Dg' * Dx ) ) * Dx * Dx' / (Dg' * Dx ) ;
% 
%         end
% 
%         descent = - H * gradient;
%         norm(descent-descent2)/norm(descent)
% 
% 









        % check if BFGS-step provides sufficient decrease; else take gradient
        lambda2 = - descent'*gradient;
        beta = descent'*gradient / norm(descent) / norm(gradient);
        if beta > -.001,

            descent = - gradient;
            beta = descent'*gradient / norm(descent) / norm(gradient);
            % re-initialize
            ln=1;
            l=0;
            S=zeros(size(x,1),lmax);
            Y=zeros(size(x,1),lmax);
            W0=1;
%             H = eye(n);
        end

        lambda2 = - gradient' * descent ;
       
        if isnan(lambda2),
            % re-initialize
            ln=1;
            l=0;
            S=zeros(size(x,1),lmax);
            Y=zeros(size(x,1),lmax);

            descent = - gradient; lambda2 = - gradient' * descent ;
%             H = eye(n);
        end
    end
    beta = descent'*gradient / norm(descent) / norm(gradient);

    lambda2crit = gradient' * gradient;
    lambda2old = lambda2;
    if display
        fprintf('k=%d - lambda2=%e - beta = %f - f=%f - df=%e - nev = %d, dx=%e,grad=%.4f\n',k,lambda2crit,...
            beta ,fx,df,kls,norm(xold-x),norm(gradient));
    end
    xold=x;
    if lambda2crit < 2 * tol
        % usual end of iteration
        go_on = 0;
        exit_parameters.type = 'small_lambda2';
        exit_parameters.lambda2 = lambda2;
        exit_parameters.k = k;
        exit_parameters.nevals = nevals;

    else

                % Wolfe line search
                a = 0;
                b = Inf;
        
                kls = 0;
                alpha = alpha0;
                alphas = [];
                falphas = [];
                while kls < kmax_ls
        
                    [falpha,gradalpha] = feval(fun,varargin{:},x + alpha * descent);
                    alphas = [ alphas alpha ];
                    falphas= [ falphas falpha ];
        
                    nevals = nevals + 1;
        
        
        
                    if (falpha > fx - m1_WOLFE * lambda2 * alpha)
                        % alpha is too large, reduce it
                        b = alpha;
                        alpha = (a+b)/2;
    			if display
                        fprintf('-');
			end
                    else
                        if gradalpha'*descent < m2_WOLFE * gradient' * descent
                            % alpha is too small
                            a = alpha;
                            alpha = 2 * alpha;
    			    if display
                            fprintf('+');
			    end	
                        else
                            % alpha is correct
                            break;
                        end
                    end
                    kls = kls + 1;
                end

%         % Goldstein line search
%         a = 0;
%         b = Inf;
%         kls = 0;
%         alpha = alpha0;
%         alphas = [];
%         falphas = [];
%         already_one = 0;
%         while kls < kmax_ls
% 
%             falpha = feval(fun,varargin{:},x + alpha * descent);
%             alphas = [ alphas alpha ];
%             falphas= [ falphas falpha ];
% 
%             nevals = nevals + 1;
%             if (falpha <= fx - rho_GOLDSTEIN * lambda2 * alpha)
%                 fprintf('+');
%                 already_one = 1;
%                 alpha = alpha * t_GOLDSTEIN * 2;
%             else
%                 fprintf('-');
%                 if kls>0,
%                     if falphas(end)>falphas(end-1), break; end
%                 end
%                 if already_one, break;
%                 else alpha = alpha / t_GOLDSTEIN; end
%             end
%             kls = kls + 1;
%         end







        %         if kls==kmax_ls, keyboard; end
        [a,b]=min(falphas);
        if isinf(a), 
            
             % usual end of iteration
        exit_parameters.type = 'linesearch infeasible';
        exit_parameters.lambda2 = lambda2;
        exit_parameters.k = k;
        exit_parameters.nevals = nevals;
return;
            
        end
        alpha = alphas(b);
        alpha0 = alpha;
        gradold = gradient;
        fxold = fx;
        xold = x;
        x = x + alpha * descent;

%        save x x
        k=k+1;
    end
end
if k==kmax,  exit_parameters.type = 'max_iterations';  end
if df<=tol^2, exit_parameters.type = 'df_small'; exit_parameters.df =df; end
exit_parameters.nevals = nevals;
exit_parameters.k=k;
