%function take file with similarity scores between pockets and list of pockets types (ligands), produce roc scores of each pocket
function [ROC RC]=process_roc(fdist,flig,fpock,fout,fdistlig);
if nargin<2
    flig='LigLst.txt';
end
if nargin<4
    fout=[fdist '_roc'];
end
if nargin<5
	fdistlig=-1;
end
if fdistlig>-1
fdistlig=load(fdistlig);
end
LigLst=textread(flig,'%s');
for i=1:length(LigLst)
if strcmp(LigLst{i},'EST')==1
	LigLst{i}='AND';
end
end
PockLst=textread(fpock,'%s');
%select only filenames
for i=1:length(PockLst)
n=find(PockLst{i}=='/');
if length(n)>0
PockLst{i}=strrep(PockLst{i}(n(end)+1:end),'_bs.pdb','');
end
end
%cluster enumeration
clust(1)=1;
for i=2:size(LigLst)
newl=-1;
for j=1:i-1
	if strcmp(LigLst{i},LigLst{j})
		newl=clust(j);
		break;	
	end
end
if newl==-1
	clust(i)=max(clust)+1;
else
	clust(i)=newl;
end
end
f=fopen(fout,'w+');NC=length(clust);       
%roc scores
D=load(fdist);ROC=[]; RC=[];
%random permutation to be sure that there is no 'original correct order'
rand('state',sum(100*clock));
randp=randperm(size(D,1));irandp(randp)=1:size(D,1);
D=D(randp,randp);clust=clust(randp);%D=D/norm(D,'fro');
for i=1:size(D,1)
    %disp(D(i,:));
    [sd id]=sort(D(i,:));
    RC(i,:)=id;
    %disp([sd;id;clust(id)==clust(i)]);
   % if strcmp(LigLst{i},'ATP')
%	disp((clust(id(2:end))==clust(i)))
%	fgd=fgd
	%disp(find(clust(id(2:end))==clust(i)))
        ROC(end+1)=roc_score(clust(id(2:end))==clust(i));
	%for j=1:max(clust)
	%	RC(j,i)=roc_score(clust(id(2:end))==j);
	%end
    if 0
        fprintf(f,'%s(%.2f) : ',LigLst{i},ROC(end));
        for j=2:NC/2
            fprintf(f,'%s  ',LigLst{id(j)});
        end
        fprintf(f,'|||');
        for j=length(LigLst)-NC/2:length(LigLst)
            fprintf(f,'%s  ',LigLst{id(j)});
        end
        fprintf(f,'\n');
     
        fprintf(f,'%s(%.2f): ',PockLst{i},ROC(end));
        for j=2:NC/2
            fprintf(f,'%s ',PockLst{id(j)});
        end
        fprintf(f,'|||');
        for j=length(LigLst)-NC/2:length(LigLst)
            fprintf(f,'%s ',PockLst{id(j)});
        end
        fprintf(f,'\n \n');
    end
end
fclose(f);
%inverse permutation for all data
RCt=RC*0;ROC=ROC(irandp);RC=RC(irandp,:);for i=1:length(irandp) RCt(RC==irandp(i))=i;end;RC=RCt;

%plugin
if 0
uclustt=unique(clust);uclust=[];
for i=1:length(uclustt)
    if length(find(clust==uclustt(i)))>8
        uclust=[uclust uclustt(i)];
    end
end
rs=[];
for j=1:length(uclust) rs(j)=roc_score(clust(id(2:end))==uclust(j));end;
[srs inrs]=sort(rs);
for i=0:10
    indf=find(clust==uclust(inrs(end-i)));
    disp([cell2mat(LigLst(indf(1))) ' ' num2str(roc_score(clust(id(2:end))==uclust(inrs(end-i))))]);
end
end
